/**
 * Appcelerator Drillbit
 * Copyright (c) 2010 by Appcelerator, Inc. All Rights Reserved.
 * Licensed under the terms of the Apache Public License
 * Please see the LICENSE included with this distribution for details.
 *
 * WARNING: this is a generated Drillbit test suite
 * -- database
 */

var testName = "database";



// top level method wrap is inverted

function runTests() {




/**
 * Appcelerator Drillbit
 * Copyright (c) 2010 by Appcelerator, Inc. All Rights Reserved.
 * Licensed under the terms of the Apache Public License
 * Please see the LICENSE included with this distribution for details.
 */
var DrillbitTest = 
{
	currentTest:null,
	results:[],
	tests:[],
	success:0,
	failed:0,
	totalAssertions:0,
	autoRun: true,
	completed: false,

	fireEvent: function(name, event) {
		event.name = name;
		event.suite = DrillbitTest.NAME;
		Titanium.API.debug('DRILLBIT_EVENT: ' + JSON.stringify(event));
	},
	
	runningTest: function(suite, name)
	{
		this.fireEvent('test', {test: name});
		appendMessage("> running test <span class=\"test\">" + name + "</span> in suite <span class=\"suite\">" + suite + "</span>");
	},
	
	assertion: function(subject)
	{
		this.fireEvent('assertion', {test: DrillbitTest.currentTest, lineNumber: subject.lineNumber});
		DrillbitTest.totalAssertions++;
	},
	
	testPassed: function(name, lineNumber)
	{
		this.success++;
		this.results.push({
			name:name,
			passed:true,
			message: "Success",
			lineNumber: lineNumber
		});
		this.fireEvent('testStatus', {test: name, lineNumber: lineNumber, passed: true, error: null});
		appendMessage('>> test <span class=\"test\">' + name + '</span> passed', 'pass');
		if (DrillbitTest.autoRun) {
			DrillbitTest.runNextTest();
		}
	},
	
	testFailed: function(name,e)
	{
		this.failed++;
		this.results.push({
			name:name,
			passed:false,
			lineNumber:e.line,
			message:e.message || String(e)
		});
		
		var errorMessage = String(e).replace("\n","\\n");
		this.fireEvent('testStatus', {test: name, lineNumber: e.line, passed: false, error: errorMessage});
		
		appendMessage('>> test <span class=\"test\">' + name + '</span> failed: line ' + e.line + ", error: " + errorMessage, 'fail');
		if (DrillbitTest.autoRun) {
			DrillbitTest.runNextTest();
		}
	},
	
	complete: function() {
		this.completed = true;
		try {
			var results = this.getResults();
			// logcat has a character limit in Android, so we save to the sdcard and pull down from Drillbit
			if (Ti.Platform.osname == "android") {
				var resultsFile = Ti.Filesystem.getFile("appdata://results.json");
				results.suite = DrillbitTest.NAME;
				resultsFile.write(JSON.stringify(results));
				this.fireEvent("completeAndroid", {});
				try {
					if (TestHarnessRunner) {
						var bundle = new (Packages.android.os.Bundle)();
						TestHarnessRunner.finish(Ti.Android.RESULT_OK, bundle);
					}
				} catch (e) {
					Titanium.API.debug('TestHarnessRunner not defined, skipping automated finish');
				}
			} else {
				this.fireEvent("complete", results);
			}
		} catch (e) {
			Titanium.API.error("Exception on completion: "+e);
		}
	},
	
	getResults: function()
	{
		return {
			'results':this.results,
			'count':this.results.length,
			'success':this.success,
			'failed':this.failed,
			'assertions':this.assertions
		};
	},
	
	onComplete: function() {
		this.complete();
	},
	
	runNextTest: function() {
		if (this.tests.length == 0) {
			this.onComplete();
		} else {
			var t = this.tests.shift();
			t();
		}
	}
};

DrillbitTest.gscope = {};
DrillbitTest.currentSubject = null;

function valueOf(obj)
{
	var subject = new DrillbitTest.Subject(obj);
	DrillbitTest.currentSubject = subject;
	return subject;
}

function fail(message, lineNumber)
{
	throw new DrillbitTest.Error(message, lineNumber);
}

DrillbitTest.Error = function(message,line)
{
	this.message = message;
	this.line = line;
};

DrillbitTest.Error.prototype.toString = function()
{
	return this.message;
};

DrillbitTest.Subject = function(target) {
	this.target = target;
	this.lineNumber = 0;
};

DrillbitTest.Subject.prototype.toString = function()
{
	return 'Subject[target='+this.target+',line='+this.lineNumber+']';
};

DrillbitTest.Scope = function(name) {
	this._testName = name;
	this._completed = false;
	// copy in the global scope
	for (var p in DrillbitTest.gscope)
	{
		this[p] = DrillbitTest.gscope[p];
	}
}

DrillbitTest.Scope.prototype.passed = function()
{
	if (!this._completed)
	{
		this._completed = true;
		if (DrillbitTest.currentSubject)
		{	
			var lineNumber = 0;
			if ("lineNumber" in DrillbitTest.currentSubject) {
				lineNumber = DrillbitTest.currentSubject.lineNumber;
			}
			DrillbitTest.testPassed(this._testName, lineNumber);

		}
		else
		{
			DrillbitTest.testPassed(this._testName,-1);
		}
		DrillbitTest.currentSubject = null;
	}
}

DrillbitTest.Scope.prototype.failed = function(ex)
{
	if (!this._completed)
	{
		this._completed = true;
		DrillbitTest.testFailed(this._testName,ex);
		DrillbitTest.currentSubject = null;
	}
}

DrillbitTest.Subject.prototype.shouldBe = function(expected,lineNumber)
{
	this.lineNumber = lineNumber;
	DrillbitTest.assertion(this);
	if (this.target != expected)
	{
		throw new DrillbitTest.Error('should be: "'+expected+'", was: "'+this.target+'"',lineNumber);
	}
};

DrillbitTest.Subject.prototype.shouldNotBe = function(expected,lineNumber)
{
	this.lineNumber = lineNumber;
	DrillbitTest.assertion(this);
	if (this.target == expected)
	{
		throw new DrillbitTest.Error('should not be: '+expected+', was: '+this.target,lineNumber);
	}
};

DrillbitTest.Subject.prototype.shouldNotBeNull = function(expected,lineNumber)
{
	this.lineNumber = lineNumber;
	DrillbitTest.assertion(this);
	if (this.target === null)
	{
		throw new DrillbitTest.Error('should not be null, was: '+this.target,lineNumber);
	}
};

DrillbitTest.Subject.prototype.shouldNotBeUndefined = function(expected,lineNumber)
{
	this.lineNumber = lineNumber;
	DrillbitTest.assertion(this);
	if (this.target === undefined)
	{
		throw new DrillbitTest.Error('should not be undefined, was: '+this.target,lineNumber);
	}
};

DrillbitTest.Subject.prototype.shouldBeExactly = function(expected,lineNumber)
{
	this.lineNumber = lineNumber;
	DrillbitTest.assertion(this);
	if (this.target !== expected)
	{
		throw new DrillbitTest.Error('should be exactly: '+expected+', was: '+this.target,lineNumber);
	}
};

DrillbitTest.Subject.prototype.shouldNotBeExactly = function(expected,lineNumber)
{
	this.lineNumber = lineNumber;
	DrillbitTest.assertion(this);
	if (this.target === expected)
	{
		throw new DrillbitTest.Error('should not be exactly: '+expected+', was: '+this.target,lineNumber);
	}
};

DrillbitTest.Subject.prototype.shouldBeNull = function(expected,lineNumber)
{
	this.lineNumber = lineNumber;
	DrillbitTest.assertion(this);
	if (this.target !== null)
	{
		throw new DrillbitTest.Error('should be null, was: '+this.target,lineNumber);
	}
};

DrillbitTest.Subject.prototype.shouldBeString = function(expected,lineNumber)
{
	this.lineNumber = lineNumber;
	DrillbitTest.assertion(this);
	if (typeof this.target !== 'string')
	{
		throw new DrillbitTest.Error('should be string, was: '+typeof(this.target),lineNumber);
	}
};

DrillbitTest.Subject.prototype.shouldBeUndefined = function(expected,lineNumber)
{
	this.lineNumber = lineNumber;
	DrillbitTest.assertion(this);
	if (this.target !== undefined)
	{
		throw new DrillbitTest.Error('should be undefined, was: '+this.target,lineNumber);
	}
};


DrillbitTest.Subject.prototype.shouldBeFunction = function(expected,lineNumber)
{
	this.lineNumber = lineNumber;
	DrillbitTest.assertion(this);
	if (typeof(this.target) != 'function')
	{
		throw new DrillbitTest.Error('should be a function, was: '+typeof(this.target),lineNumber);
	}
};

DrillbitTest.Subject.prototype.shouldBeObject = function(expected,lineNumber)
{
	this.lineNumber = lineNumber;
	DrillbitTest.assertion(this);
	if (typeof(this.target) != 'object')
	{
		throw new DrillbitTest.Error('should be a object, was: '+typeof(this.target),lineNumber);
	}
};

DrillbitTest.Subject.prototype.shouldBeNumber = function(expected,lineNumber)
{
	this.lineNumber = lineNumber;
	DrillbitTest.assertion(this);
	if (typeof(this.target) != 'number')
	{
		throw new DrillbitTest.Error('should be a number, was: '+typeof(this.target),lineNumber);
	}
};

DrillbitTest.Subject.prototype.shouldBeBoolean = function(expected,lineNumber)
{
	this.lineNumber = lineNumber;
	DrillbitTest.assertion(this);
	if (typeof(this.target) != 'boolean')
	{
		throw new DrillbitTest.Error('should be a boolean, was: '+typeof(this.target),lineNumber);
	}
};

DrillbitTest.Subject.prototype.shouldBeTrue = function(expected,lineNumber)
{
	this.lineNumber = lineNumber;
	DrillbitTest.assertion(this);
	if (this.target!==true)
	{
		throw new DrillbitTest.Error('should be true, was: '+this.target,lineNumber);
	}
};

DrillbitTest.Subject.prototype.shouldBeFalse = function(expected,lineNumber)
{
	this.lineNumber = lineNumber;
	DrillbitTest.assertion(this);
	if (this.target!==false)
	{
		throw new DrillbitTest.Error('should be false, was: '+this.target,lineNumber);
	}
};

DrillbitTest.Subject.prototype.shouldBeZero = function(expected,lineNumber)
{
	this.lineNumber = lineNumber;
	DrillbitTest.assertion(this);
	if (this.target!==0)
	{
		throw new DrillbitTest.Error('should be 0 (zero), was: '+this.target+' ('+typeof(this.target)+')',lineNumber);
	}
};

DrillbitTest.Subject.prototype.shouldBeArray = function(expected,lineNumber)
{
	this.lineNumber = lineNumber;
	DrillbitTest.assertion(this);
	// better way to check? we need to support our duck-typing too..
	if (this.target.constructor != Array)
	{
		throw new DrillbitTest.Error('should be an array, was: '+this.target,lineNumber);
	}
};

DrillbitTest.Subject.prototype.shouldContain = function(expected,lineNumber)
{
	this.lineNumber = lineNumber;
	DrillbitTest.assertion(this);
	if (this.target.indexOf(expected)==-1)
	{
		throw new DrillbitTest.Error('should contain: '+expected+', was: '+this.target,lineNumber);
	}
};

DrillbitTest.Subject.prototype.shouldBeOneOf = function(expected,lineNumber)
{
	this.lineNumber = lineNumber;
	DrillbitTest.assertion(this);
	if (expected.indexOf(this.target)==-1)
	{
		throw new DrillbitTest.Error('should contain one of: ['+expected.join(",")+'] was: '+this.target,lineNumber);
	}
};

DrillbitTest.Subject.prototype.shouldMatchArray = function(expected,lineNumber)
{
	this.lineNumber = lineNumber;
	DrillbitTest.assertion(this);
	if (this.target.length && expected.length && this.target.length == expected.length) {
		for (var i = 0; i < expected.length; i++) {
			if (expected[i] != this.target[i]) {
				throw new DrillbitTest.Error('element ' + i + ' should be: '+expected[i]+' was: '+this.target[i],lineNumber);
			}
		}
	}
	else {
		throw new DrillbitTest.Error('array lengths differ, expected: '+expected+', was: '+this.target,lineNumber);
	}
};

DrillbitTest.Subject.prototype.shouldBeGreaterThan = function(expected, lineNumber)
{
	this.lineNumber = lineNumber;
	DrillbitTest.assertion(this);
	if (this.target <= expected)
	{
		throw new DrillbitTest.Error('should be greater than, was ' + this.target + ' <= ' + expected,lineNumber);
	}
};

DrillbitTest.Subject.prototype.shouldBeLessThan = function(expected, lineNumber)
{
	this.lineNumber = lineNumber;
	DrillbitTest.assertion(this);
	if (this.target >= expected)
	{
		throw new DrillbitTest.Error('should be less than, was ' + this.target + ' >= ' + expected,lineNumber);
	}
};

DrillbitTest.Subject.prototype.shouldBeGreaterThanEqual = function(expected, lineNumber)
{
	this.lineNumber = lineNumber;
	DrillbitTest.assertion(this);
	if (this.target < expected)
	{
		throw new DrillbitTest.Error('should be greater than equal, was ' + this.target + ' < ' + expected,lineNumber);
	}
};

DrillbitTest.Subject.prototype.shouldBeLessThanEqual = function(expected, lineNumber)
{
	this.lineNumber = lineNumber;
	DrillbitTest.assertion(this);
	if (this.target > expected)
	{
		throw new DrillbitTest.Error('should be greater than, was ' + this.target + ' > ' + expected,lineNumber);
	}
};

DrillbitTest.Subject.prototype.shouldThrowException = function(expected,lineNumber)
{
/*
	if (Titanium.Platform.name == 'iPhone OS' || Titanium.Platform.name == 'iOS')
	{
		// iOS 4.0+ Simulator doesn't correctly propagate exceptions, so we ignore
		// for iOS and issue a warning. Ticket:
		// http://jira.appcelerator.org/browse/TIMOB-3561
		Ti.API.warn("Not running test: ignoring shouldThrowException on line " + lineNumber + " in iOS, see http://jira.appcelerator.org/browse/TIMOB-3561");
		
		this.lineNumber = lineNumber;
		DrillbitTest.assertion(this);
		return;
	}
*/

	this.lineNumber = lineNumber;
	DrillbitTest.assertion(this);
	if (typeof(this.target) == 'function')
	{
		try {
			this.target();
		} catch (e) { return; }
		throw new DrillbitTest.Error("should throw exception, but didn't",lineNumber);
	}
	else throw new DrillbitTest.Error("should throw exception, but target isn't a function",lineNumber);
};

DrillbitTest.Subject.prototype.shouldNotThrowException = function(expected,lineNumber)
{
	this.lineNumber = lineNumber;
	DrillbitTest.assertion(this);
	if (typeof(this.target) == 'function')
	{
		try {
			this.target();
		} catch (e) { 
			throw new DrillbitTest.Error("should not throw exception, but did",lineNumber);	
		}
	}
	else throw new DrillbitTest.Error("should not throw exception, but target isn't a function",lineNumber);
};

function AsyncTest(args) {
	this.startFn = args.start;
	this.timeout = args.timeout || null;
	this.timeoutError = args.timeoutError || null;
	this.onTimeoutFn = args.onTimeout || null;
	this.timer = null;
};

AsyncTest.prototype.async = function(fn) {
	var self = this;
	return function() {
		try {
			if (self.timer != null) {
				clearTimeout(self.timer);
			}
			
			fn.apply(this, arguments);
			self.callback.passed();
		} catch (e) {
			self.callback.failed(e);
		}
	};
};

AsyncTest.prototype.start = function(callback) {
	this.callback = callback;
	try {
		this.result = this.startFn.apply(this, [callback]);
		if (this.timeout != null) {
			var self = this;
			this.timer = setTimeout(function() {
				if (self.onTimeoutFn != null) {
					try {
						this.onTimeoutFn.apply(this, [this.result]);
						callback.passed();
					} catch (e) {
						callback.failed(e);
					}
				} else {
					var message = self.timeoutError || "Error: Timed out (" + self.timeout + "ms)";
					callback.failed(message);
				}
			}, this.timeout);
		}
	} catch (e) {
		callback.failed(e);
		return;
	}
};

function asyncTest(args) {
	args = typeof(args) == 'function' ? {start: args} : args;
	return new AsyncTest(args);
};

DrillbitTest.NAME = "database";
DrillbitTest.SOURCE = "/Users/stiv/src/appcelerator/titanium_mobile/drillbit/tests/database/database.js";
DrillbitTest.autoRun = true;


try
{
	appendMessage('running suite <span class="suite">' + DrillbitTest.NAME + '</span> before_all');
	
}
catch (e)
{
	Titanium.API.error('before_all caught error:'+e+' at line: '+e.line);
}





		var testModuleMethodsAndConstants_wrapper = function() {
			var xscope = new DrillbitTest.Scope('testModuleMethodsAndConstants');
			;

			try {
				var initialAssertions = DrillbitTest.totalAssertions;
				DrillbitTest.currentTest = 'testModuleMethodsAndConstants';
				DrillbitTest.runningTest('database', 'testModuleMethodsAndConstants');
				(function(){var _scope = xscope;
(function () {
		valueOf(Ti.Database).shouldNotBeNull(null,3);
		valueOf(Ti.Database).shouldBeObject(null,4);
		valueOf(Ti.Database.open).shouldBeFunction(null,5);
		valueOf(Ti.Database.install).shouldBeFunction(null,6);
		
		valueOf(Ti.Database.FIELD_TYPE_STRING).shouldNotBeNull(null,8);
		valueOf(Ti.Database.FIELD_TYPE_INT).shouldNotBeNull(null,9);
		valueOf(Ti.Database.FIELD_TYPE_FLOAT).shouldNotBeNull(null,10);
		valueOf(Ti.Database.FIELD_TYPE_DOUBLE).shouldNotBeNull(null,11);
	}
).call(_scope,_scope);
})();
;
				
					var finalAssertions = DrillbitTest.totalAssertions;
					if (finalAssertions - initialAssertions == 0) {
						Titanium.API.warn('No assertions in test function: testModuleMethodsAndConstants');
					}
					var lineNumber = 0;
					if (DrillbitTest.currentSubject) {
						if ("lineNumber" in DrillbitTest.currentSubject) {
							lineNumber = DrillbitTest.currentSubject.lineNumber;
						}					
					}
					DrillbitTest.testPassed('testModuleMethodsAndConstants',lineNumber);
				
			}
			catch (___e)
			{
				// wrap the exception message so we can report the failed test's line number
				var ___err = {
					message: ___e.message || ("Non-assertion exception: " + String(___e)),
					line: ___e.constructor == DrillbitTest.Error ? ___e.line : 1,
					toString: function() { return this.message; }
				};
				DrillbitTest.testFailed('testModuleMethodsAndConstants', ___err);
			}

			
			// --- testModuleMethodsAndConstants ---
		};
		
		testModuleMethodsAndConstants_wrapper.testName = "testModuleMethodsAndConstants";
		DrillbitTest.tests.push(testModuleMethodsAndConstants_wrapper);


		var testDatabaseMethods_wrapper = function() {
			var xscope = new DrillbitTest.Scope('testDatabaseMethods');
			;

			try {
				var initialAssertions = DrillbitTest.totalAssertions;
				DrillbitTest.currentTest = 'testDatabaseMethods';
				DrillbitTest.runningTest('database', 'testDatabaseMethods');
				(function(){var _scope = xscope;
(function () {
		var db = Ti.Database.open("Test");
		try {
			valueOf(db).shouldNotBeNull(null,16);
			valueOf(db).shouldBeObject(null,17);
			valueOf(db.close).shouldBeFunction(null,18);
			valueOf(db.execute).shouldBeFunction(null,19);
			valueOf(db.getLastInsertRowId).shouldBeFunction(null,20);
			valueOf(db.getName).shouldBeFunction(null,21);
			valueOf(db.getRowsAffected).shouldBeFunction(null,22);
			valueOf(db.remove).shouldBeFunction(null,23);
		
			// Properties
			valueOf(db.lastInsertRowId).shouldBeNumber(null,26);
			valueOf(db.name).shouldBeString(null,27);
			valueOf(db.name).shouldBe("Test",28);
			valueOf(db.rowsAffected).shouldBeNumber(null,29);
		} finally {
			db.close();
		}
	}
).call(_scope,_scope);
})();
;
				
					var finalAssertions = DrillbitTest.totalAssertions;
					if (finalAssertions - initialAssertions == 0) {
						Titanium.API.warn('No assertions in test function: testDatabaseMethods');
					}
					var lineNumber = 0;
					if (DrillbitTest.currentSubject) {
						if ("lineNumber" in DrillbitTest.currentSubject) {
							lineNumber = DrillbitTest.currentSubject.lineNumber;
						}					
					}
					DrillbitTest.testPassed('testDatabaseMethods',lineNumber);
				
			}
			catch (___e)
			{
				// wrap the exception message so we can report the failed test's line number
				var ___err = {
					message: ___e.message || ("Non-assertion exception: " + String(___e)),
					line: ___e.constructor == DrillbitTest.Error ? ___e.line : 12,
					toString: function() { return this.message; }
				};
				DrillbitTest.testFailed('testDatabaseMethods', ___err);
			}

			
			// --- testDatabaseMethods ---
		};
		
		testDatabaseMethods_wrapper.testName = "testDatabaseMethods";
		DrillbitTest.tests.push(testDatabaseMethods_wrapper);


		var testDatabaseLH2147_wrapper = function() {
			var xscope = new DrillbitTest.Scope('testDatabaseLH2147');
			;

			try {
				var initialAssertions = DrillbitTest.totalAssertions;
				DrillbitTest.currentTest = 'testDatabaseLH2147';
				DrillbitTest.runningTest('database', 'testDatabaseLH2147');
				(function(){var _scope = xscope;
(function () {
		var db = Ti.Database.open("Test");
		try {
			valueOf(db).shouldNotBeNull(null,38);
		
			var rs = db.execute("drop table if exists Test");
			valueOf(rs).shouldBeNull(null,41);

			rs = db.execute("create table if not exists Test(row text)");
			valueOf(rs).shouldBeNull(null,44);
		
			rs = db.execute("pragma table_info(Test)");
			valueOf(rs).shouldNotBeNull(null,47);
			valueOf(rs.fieldCount).shouldBeGreaterThan(0,48);
			rs.close();
		
			rs = db.execute("select * from Test");
			valueOf(rs).shouldNotBeNull(null,52);
			valueOf(rs.getFieldCount()).shouldBe(1,53);
			valueOf(rs.rowCount).shouldBe(0,54);
			rs.close();
		} finally {
			db.close();
			db.remove();
		}
		
		var f = Ti.Filesystem.getFile("file:///data/data/org.appcelerator.titanium.testharness/databases/Test");
		valueOf(f.exists()).shouldBeFalse(null,62);
	}
).call(_scope,_scope);
})();
;
				
					var finalAssertions = DrillbitTest.totalAssertions;
					if (finalAssertions - initialAssertions == 0) {
						Titanium.API.warn('No assertions in test function: testDatabaseLH2147');
					}
					var lineNumber = 0;
					if (DrillbitTest.currentSubject) {
						if ("lineNumber" in DrillbitTest.currentSubject) {
							lineNumber = DrillbitTest.currentSubject.lineNumber;
						}					
					}
					DrillbitTest.testPassed('testDatabaseLH2147',lineNumber);
				
			}
			catch (___e)
			{
				// wrap the exception message so we can report the failed test's line number
				var ___err = {
					message: ___e.message || ("Non-assertion exception: " + String(___e)),
					line: ___e.constructor == DrillbitTest.Error ? ___e.line : 34,
					toString: function() { return this.message; }
				};
				DrillbitTest.testFailed('testDatabaseLH2147', ___err);
			}

			
			// --- testDatabaseLH2147 ---
		};
		
		testDatabaseLH2147_wrapper.testName = "testDatabaseLH2147";
		DrillbitTest.tests.push(testDatabaseLH2147_wrapper);


		var testDatabaseInsert_wrapper = function() {
			var xscope = new DrillbitTest.Scope('testDatabaseInsert');
			;

			try {
				var initialAssertions = DrillbitTest.totalAssertions;
				DrillbitTest.currentTest = 'testDatabaseInsert';
				DrillbitTest.runningTest('database', 'testDatabaseInsert');
				(function(){var _scope = xscope;
(function () {
		var db = Ti.Database.open("Test");
		try {
			valueOf(db).shouldNotBeNull(null,67);
		
			var rs = db.execute("drop table if exists Test");
			valueOf(rs).shouldBeNull(null,70);

			rs = db.execute("create table if not exists Test(row text)");
			valueOf(rs).shouldBeNull(null,73);

			db.execute("insert into Test(row) values(?)", "My TestRow");
		
			rs = db.execute("select * from Test");
			valueOf(rs).shouldNotBeNull(null,78);
			valueOf(rs.isValidRow()).shouldBe(true,79);
			valueOf(rs.getFieldCount()).shouldBe(1,80);
			valueOf(rs.rowCount).shouldBe(1,81);
			valueOf(rs.getField(0)).shouldBe("My TestRow",82);
			rs.close();
		} finally {
			db.close();
			db.remove();
		}
		
		var f = Ti.Filesystem.getFile("file:///data/data/org.appcelerator.titanium.testharness/databases/Test");
		valueOf(f.exists()).shouldBeFalse(null,90);
	}
).call(_scope,_scope);
})();
;
				
					var finalAssertions = DrillbitTest.totalAssertions;
					if (finalAssertions - initialAssertions == 0) {
						Titanium.API.warn('No assertions in test function: testDatabaseInsert');
					}
					var lineNumber = 0;
					if (DrillbitTest.currentSubject) {
						if ("lineNumber" in DrillbitTest.currentSubject) {
							lineNumber = DrillbitTest.currentSubject.lineNumber;
						}					
					}
					DrillbitTest.testPassed('testDatabaseInsert',lineNumber);
				
			}
			catch (___e)
			{
				// wrap the exception message so we can report the failed test's line number
				var ___err = {
					message: ___e.message || ("Non-assertion exception: " + String(___e)),
					line: ___e.constructor == DrillbitTest.Error ? ___e.line : 63,
					toString: function() { return this.message; }
				};
				DrillbitTest.testFailed('testDatabaseInsert', ___err);
			}

			
			// --- testDatabaseInsert ---
		};
		
		testDatabaseInsert_wrapper.testName = "testDatabaseInsert";
		DrillbitTest.tests.push(testDatabaseInsert_wrapper);


		var testDatabaseCount_wrapper = function() {
			var xscope = new DrillbitTest.Scope('testDatabaseCount');
			;

			try {
				var initialAssertions = DrillbitTest.totalAssertions;
				DrillbitTest.currentTest = 'testDatabaseCount';
				DrillbitTest.runningTest('database', 'testDatabaseCount');
				(function(){var _scope = xscope;
(function () {
		var testRowCount = 100;
		var db = Ti.Database.open('Test');
		try {
			valueOf(db).shouldNotBeNull(null,96);
			
			var rs = db.execute("drop table if exists data");
			valueOf(rs).shouldBeNull(null,99);
			
			db.execute('CREATE TABLE IF NOT EXISTS data (id INTEGER PRIMARY KEY, val TEXT)');
			for (var i = 1; i <= testRowCount; i++) {
			    db.execute('INSERT INTO data (val) VALUES(?)','our value:' + i);
			}

		    rs = db.execute("SELECT * FROM data");
		    var rowCount = rs.rowCount;
		    var realCount = 0;
		    while (rs.isValidRow()) {
		        realCount += 1;
		        rs.next();
		    }
			rs.close();
			
		    valueOf(realCount).shouldBe(testRowCount,115);
		    valueOf(rowCount).shouldBe(testRowCount,116);
		    valueOf(rowCount).shouldBe(realCount,117);
		} finally {
			db.close();
			db.remove();
		}
	}
).call(_scope,_scope);
})();
;
				
					var finalAssertions = DrillbitTest.totalAssertions;
					if (finalAssertions - initialAssertions == 0) {
						Titanium.API.warn('No assertions in test function: testDatabaseCount');
					}
					var lineNumber = 0;
					if (DrillbitTest.currentSubject) {
						if ("lineNumber" in DrillbitTest.currentSubject) {
							lineNumber = DrillbitTest.currentSubject.lineNumber;
						}					
					}
					DrillbitTest.testPassed('testDatabaseCount',lineNumber);
				
			}
			catch (___e)
			{
				// wrap the exception message so we can report the failed test's line number
				var ___err = {
					message: ___e.message || ("Non-assertion exception: " + String(___e)),
					line: ___e.constructor == DrillbitTest.Error ? ___e.line : 91,
					toString: function() { return this.message; }
				};
				DrillbitTest.testFailed('testDatabaseCount', ___err);
			}

			
			// --- testDatabaseCount ---
		};
		
		testDatabaseCount_wrapper.testName = "testDatabaseCount";
		DrillbitTest.tests.push(testDatabaseCount_wrapper);


		var testDatabaseRollback_wrapper = function() {
			var xscope = new DrillbitTest.Scope('testDatabaseRollback');
			;

			try {
				var initialAssertions = DrillbitTest.totalAssertions;
				DrillbitTest.currentTest = 'testDatabaseRollback';
				DrillbitTest.runningTest('database', 'testDatabaseRollback');
				(function(){var _scope = xscope;
(function () {
		var db = Ti.Database.open('Test');
		var testRowCount = 30;
		try {
			valueOf(db).shouldNotBeNull(null,127);
			
			var rs = db.execute("drop table if exists data");
			valueOf(rs).shouldBeNull(null,130);
			
			db.execute('CREATE TABLE IF NOT EXISTS data (id INTEGER PRIMARY KEY, val TEXT)');
			
			db.execute('BEGIN TRANSACTION');
			for (var i = 1; i <= testRowCount; i++) {
			    db.execute('INSERT INTO data (val) VALUES(?)','our value:' + i);
			}
			rs = db.execute("SELECT * FROM data");
		    valueOf(rs.rowCount).shouldBe(testRowCount,139);
			rs.close();
			
			db.execute('ROLLBACK TRANSACTION');
		
			rs = db.execute("SELECT * FROM data");
			valueOf(rs.rowCount).shouldBe(0,145);
			rs.close();
		
			db.execute('drop table if exists data');
		} finally {
			db.close();
			db.remove();
		}
	}
).call(_scope,_scope);
})();
;
				
					var finalAssertions = DrillbitTest.totalAssertions;
					if (finalAssertions - initialAssertions == 0) {
						Titanium.API.warn('No assertions in test function: testDatabaseRollback');
					}
					var lineNumber = 0;
					if (DrillbitTest.currentSubject) {
						if ("lineNumber" in DrillbitTest.currentSubject) {
							lineNumber = DrillbitTest.currentSubject.lineNumber;
						}					
					}
					DrillbitTest.testPassed('testDatabaseRollback',lineNumber);
				
			}
			catch (___e)
			{
				// wrap the exception message so we can report the failed test's line number
				var ___err = {
					message: ___e.message || ("Non-assertion exception: " + String(___e)),
					line: ___e.constructor == DrillbitTest.Error ? ___e.line : 122,
					toString: function() { return this.message; }
				};
				DrillbitTest.testFailed('testDatabaseRollback', ___err);
			}

			
			// --- testDatabaseRollback ---
		};
		
		testDatabaseRollback_wrapper.testName = "testDatabaseRollback";
		DrillbitTest.tests.push(testDatabaseRollback_wrapper);


		var testDatabaseSavepointRollback_wrapper = function() {
			var xscope = new DrillbitTest.Scope('testDatabaseSavepointRollback');
			;

			try {
				var initialAssertions = DrillbitTest.totalAssertions;
				DrillbitTest.currentTest = 'testDatabaseSavepointRollback';
				DrillbitTest.runningTest('database', 'testDatabaseSavepointRollback');
				(function(){var _scope = xscope;
(function () {
		var db = Ti.Database.open('Test');
		var testRowCount = 30;
		try {
			valueOf(db).shouldNotBeNull(null,158);
			
			var rs = db.execute("drop table if exists data");
			valueOf(rs).shouldBeNull(null,161);
			
			// Devices with Android API Levels before 8 don't support savepoints causing
			// a false failure on those devices. Try and detect and only do
			// this complex test if savepoints work 
			var savepointSupported = true;
			try {
				db.execute('SAVEPOINT test');
				db.execute('RELEASE SAVEPOINT test');
			} catch (E) {
				savepointSupported = false;
			}
			
			if (savepointSupported) {
				db.execute('BEGIN DEFERRED TRANSACTION');
				db.execute('CREATE TABLE IF NOT EXISTS data (id INTEGER PRIMARY KEY, val TEXT)');
				db.execute('SAVEPOINT FOO');
				for (var i = 1; i <= testRowCount; i++) {
				    db.execute('INSERT INTO data (val) VALUES(?)','our value:' + i);
				}
				db.execute('ROLLBACK TRANSACTION TO SAVEPOINT FOO');
				db.execute('COMMIT TRANSACTION');
			
				rs = db.execute("SELECT * FROM data");
				valueOf(rs.rowCount).shouldBe(0,185);
				rs.close();
			
				db.execute('BEGIN TRANSACTION');
				db.execute('drop table if exists data');
				db.execute('ROLLBACK TRANSACTION');
			
				rs = db.execute("SELECT * FROM data");
				valueOf(rs).shouldNotBeNull(null,193);
				rs.close();
			}
		} finally {
			db.close();
			db.remove();
		}
	}
).call(_scope,_scope);
})();
;
				
					var finalAssertions = DrillbitTest.totalAssertions;
					if (finalAssertions - initialAssertions == 0) {
						Titanium.API.warn('No assertions in test function: testDatabaseSavepointRollback');
					}
					var lineNumber = 0;
					if (DrillbitTest.currentSubject) {
						if ("lineNumber" in DrillbitTest.currentSubject) {
							lineNumber = DrillbitTest.currentSubject.lineNumber;
						}					
					}
					DrillbitTest.testPassed('testDatabaseSavepointRollback',lineNumber);
				
			}
			catch (___e)
			{
				// wrap the exception message so we can report the failed test's line number
				var ___err = {
					message: ___e.message || ("Non-assertion exception: " + String(___e)),
					line: ___e.constructor == DrillbitTest.Error ? ___e.line : 153,
					toString: function() { return this.message; }
				};
				DrillbitTest.testFailed('testDatabaseSavepointRollback', ___err);
			}

			
			// --- testDatabaseSavepointRollback ---
		};
		
		testDatabaseSavepointRollback_wrapper.testName = "testDatabaseSavepointRollback";
		DrillbitTest.tests.push(testDatabaseSavepointRollback_wrapper);


		var testDatabaseLH2917_wrapper = function() {
			var xscope = new DrillbitTest.Scope('testDatabaseLH2917');
			;

			try {
				var initialAssertions = DrillbitTest.totalAssertions;
				DrillbitTest.currentTest = 'testDatabaseLH2917';
				DrillbitTest.runningTest('database', 'testDatabaseLH2917');
				(function(){var _scope = xscope;
(function () {
		var db = Titanium.Database.open('Test'),
		    rowCount = 10,
				resultSet, i, counter;

		
		valueOf(db).shouldBeObject(null,208);
		valueOf(resultSet).shouldBeUndefined(null,209);
		valueOf(i).shouldBeUndefined(null,210);
		valueOf(counter).shouldBeUndefined(null,211);

		try {
			db.execute('CREATE TABLE IF NOT EXISTS stuff (id INTEGER, val TEXT)');
			db.execute('DELETE FROM stuff'); //clear table of all existing data

		  //test that the execute method works with and without an array as the second argument

			for(i = 1; i <= rowCount / 2; ++i) {
				 db.execute('INSERT INTO stuff (id, val) VALUES(?, ?)', i, 'our value' + i);
			}

			while(i <= rowCount) {
				 db.execute('INSERT INTO stuff (id, val) VALUES(?, ?)', [i, 'our value' + i]);
				 ++i;
			}

			resultSet = db.execute('SELECT * FROM stuff');
			
			valueOf(resultSet).shouldNotBeNull(null,230);
			valueOf(resultSet).shouldBeObject(null,231);
			valueOf(resultSet.rowCount).shouldBe(rowCount,232);

			counter = 1;
			while(resultSet.isValidRow()) {
				valueOf(resultSet.fieldByName('id')).shouldBe(counter,236);
			  valueOf(resultSet.fieldByName('val')).shouldBe('our value' + counter,237);
			  ++counter;

				resultSet.next();
			}
			resultSet.close()
		} catch(e) {
			Titanium.API.debug('error occurred: ' + e);
		} finally {
			db.close();
			db.remove();
	 	}
	}
).call(_scope,_scope);
})();
;
				
					var finalAssertions = DrillbitTest.totalAssertions;
					if (finalAssertions - initialAssertions == 0) {
						Titanium.API.warn('No assertions in test function: testDatabaseLH2917');
					}
					var lineNumber = 0;
					if (DrillbitTest.currentSubject) {
						if ("lineNumber" in DrillbitTest.currentSubject) {
							lineNumber = DrillbitTest.currentSubject.lineNumber;
						}					
					}
					DrillbitTest.testPassed('testDatabaseLH2917',lineNumber);
				
			}
			catch (___e)
			{
				// wrap the exception message so we can report the failed test's line number
				var ___err = {
					message: ___e.message || ("Non-assertion exception: " + String(___e)),
					line: ___e.constructor == DrillbitTest.Error ? ___e.line : 201,
					toString: function() { return this.message; }
				};
				DrillbitTest.testFailed('testDatabaseLH2917', ___err);
			}

			
			// --- testDatabaseLH2917 ---
		};
		
		testDatabaseLH2917_wrapper.testName = "testDatabaseLH2917";
		DrillbitTest.tests.push(testDatabaseLH2917_wrapper);


		var testTypedGettersAndSetters_wrapper = function() {
			var xscope = new DrillbitTest.Scope('testTypedGettersAndSetters');
			;

			try {
				var initialAssertions = DrillbitTest.totalAssertions;
				DrillbitTest.currentTest = 'testTypedGettersAndSetters';
				DrillbitTest.runningTest('database', 'testTypedGettersAndSetters');
				(function(){var _scope = xscope;
(function () {
		var db   = Ti.Database.open('Test'),
		rowCount = 10,
		resultSet = null,
		i, counter, current_float, float_factor = 0.5555;

		var isAndroid = (Ti.Platform.osname === 'android');
		valueOf(db).shouldBeObject(null,259);

		try {
			counter = 1;
			i = 1;
			
			db.execute('CREATE TABLE IF NOT EXISTS stuff (id INTEGER, f REAL, val TEXT)');
			db.execute('DELETE FROM stuff;'); //clear table of all existing data
	
			var insert_float;
			while(i <= rowCount) {
			   insert_float = float_factor * i;
				 db.execute('INSERT INTO stuff (id, f, val) VALUES(?, ?, ?)', [i, insert_float, 'our value' + i]);
				 ++i;
			}
			
			resultSet = db.execute('SELECT * FROM stuff');
			
			valueOf(resultSet).shouldNotBeNull(null,277);
			valueOf(resultSet).shouldBeObject(null,278);
			valueOf(resultSet.rowCount).shouldBe(rowCount,279);

			while(resultSet.isValidRow()) {
				
				current_float = counter * float_factor;
				
				valueOf(resultSet.fieldByName('id', Ti.Database.FIELD_TYPE_INT)).shouldBe(resultSet.field(0, Ti.Database.FIELD_TYPE_INT),285);
				valueOf(resultSet.fieldByName('id', Ti.Database.FIELD_TYPE_INT)).shouldBe(counter,286);
				
			  	valueOf(resultSet.fieldByName('id', Ti.Database.FIELD_TYPE_INT)).shouldBe(counter,288);
				valueOf(resultSet.fieldByName('id', Ti.Database.FIELD_TYPE_INT)).shouldBe(counter,289);

				valueOf(resultSet.fieldByName('f', Ti.Database.FIELD_TYPE_INT)).shouldBe(resultSet.field(1, Ti.Database.FIELD_TYPE_INT),291);
				valueOf(resultSet.fieldByName('f', Ti.Database.FIELD_TYPE_INT)).shouldBe(parseInt(counter * float_factor),292);
				
				var f_val = resultSet.fieldByName('f', Ti.Database.FIELD_TYPE_FLOAT);
 	  			valueOf(Math.floor(Math.round(f_val * 10000))/10000).shouldBe(current_float,295);
				valueOf(resultSet.fieldByName('f', Ti.Database.FIELD_TYPE_DOUBLE)).shouldBe(current_float,296);
				
				valueOf(resultSet.fieldByName('val', Ti.Database.FIELD_TYPE_STRING)).shouldBe('our value' + counter,298);
				valueOf(resultSet.fieldByName('id', Ti.Database.FIELD_TYPE_STRING)).shouldBe(counter.toString(),299);
				valueOf(resultSet.fieldByName('f', Ti.Database.FIELD_TYPE_STRING)).shouldBe(current_float.toString(),300);
				
				
				// WARNING: On iOS, the following functions throw an uncaught exception - 

					valueOf(function() {
						resultSet.fieldByName('val', Ti.Database.FIELD_TYPE_INT);
					}).shouldThrowException(null,307);
				
					valueOf(function() {
						resultSet.fieldByName('val', Ti.Database.FIELD_TYPE_DOUBLE);
					}).shouldThrowException(null,311);
				
					valueOf(function() {
						resultSet.fieldByName('val', Ti.Database.FIELD_TYPE_FLOAT);
					}).shouldThrowException(null,315);
				
					valueOf(function() {
						resultSet.field(2, Ti.Database.FIELD_TYPE_DOUBLE);
					}).shouldThrowException(null,319);
				
					valueOf(function() {
						resultSet.field(2, Ti.Database.FIELD_TYPE_FLOAT);
					}).shouldThrowException(null,323);
				
					valueOf(function() {
						resultSet.field(2, Ti.Database.FIELD_TYPE_INT);
					}).shouldThrowException(null,327);

			  ++counter;

				resultSet.next();
			}
			
		} finally {
			if(null != db) {
				db.close();
			}

			if(null != resultSet) {
				resultSet.close();
			}
		}
	}
).call(_scope,_scope);
})();
;
				
					var finalAssertions = DrillbitTest.totalAssertions;
					if (finalAssertions - initialAssertions == 0) {
						Titanium.API.warn('No assertions in test function: testTypedGettersAndSetters');
					}
					var lineNumber = 0;
					if (DrillbitTest.currentSubject) {
						if ("lineNumber" in DrillbitTest.currentSubject) {
							lineNumber = DrillbitTest.currentSubject.lineNumber;
						}					
					}
					DrillbitTest.testPassed('testTypedGettersAndSetters',lineNumber);
				
			}
			catch (___e)
			{
				// wrap the exception message so we can report the failed test's line number
				var ___err = {
					message: ___e.message || ("Non-assertion exception: " + String(___e)),
					line: ___e.constructor == DrillbitTest.Error ? ___e.line : 251,
					toString: function() { return this.message; }
				};
				DrillbitTest.testFailed('testTypedGettersAndSetters', ___err);
			}

			
			// --- testTypedGettersAndSetters ---
		};
		
		testTypedGettersAndSetters_wrapper.testName = "testTypedGettersAndSetters";
		DrillbitTest.tests.push(testTypedGettersAndSetters_wrapper);


		var testDatabaseExceptions_wrapper = function() {
			var xscope = new DrillbitTest.Scope('testDatabaseExceptions');
			;

			try {
				var initialAssertions = DrillbitTest.totalAssertions;
				DrillbitTest.currentTest = 'testDatabaseExceptions';
				DrillbitTest.runningTest('database', 'testDatabaseExceptions');
				(function(){var _scope = xscope;
(function () {
			valueOf( function() { Ti.Database.open("fred://\\"); }).shouldThrowException(null,345);
			var db = null;
			try {
				db = Titanium.Database.open('Test');
			
				valueOf( function() { 
					Ti.Database.execute("select * from notATable"); 
				}).shouldThrowException(null,352);
			
				db.execute('CREATE TABLE IF NOT EXISTS stuff (id INTEGER, val TEXT)');
				db.execute('INSERT INTO stuff (id, val) values (1, "One")');
				var rs = db.execute("SELECT id FROM stuff WHERE id = 1");
				
				valueOf( function() {
					rs.field(2);
				}).shouldThrowException(null,360);
	
				valueOf( function() {
					rs.field(2);
				}).shouldThrowException(null,364);
			
				valueOf( function() {
					rs.fieldName(2);
				}).shouldThrowException(null,368);
			
				if (rs != null) {
					rs.close();
				}
			} finally {
				if (db != null) {
					db.close();
				db.remove();
				}
			}
	}
).call(_scope,_scope);
})();
;
				
					var finalAssertions = DrillbitTest.totalAssertions;
					if (finalAssertions - initialAssertions == 0) {
						Titanium.API.warn('No assertions in test function: testDatabaseExceptions');
					}
					var lineNumber = 0;
					if (DrillbitTest.currentSubject) {
						if ("lineNumber" in DrillbitTest.currentSubject) {
							lineNumber = DrillbitTest.currentSubject.lineNumber;
						}					
					}
					DrillbitTest.testPassed('testDatabaseExceptions',lineNumber);
				
			}
			catch (___e)
			{
				// wrap the exception message so we can report the failed test's line number
				var ___err = {
					message: ___e.message || ("Non-assertion exception: " + String(___e)),
					line: ___e.constructor == DrillbitTest.Error ? ___e.line : 343,
					toString: function() { return this.message; }
				};
				DrillbitTest.testFailed('testDatabaseExceptions', ___err);
			}

			
			// --- testDatabaseExceptions ---
		};
		
		testDatabaseExceptions_wrapper.testName = "testDatabaseExceptions";
		DrillbitTest.tests.push(testDatabaseExceptions_wrapper);


	DrillbitTest.AFTER_ALL = DrillbitTest.onComplete = function() {
		try {
			appendMessage('running suite <span class="suite">' + DrillbitTest.NAME + '</span> after_all');
			;
		} catch (e) {
			Titanium.API.error('after_all caught error:'+e+' at line: '+e.line);
		}
		DrillbitTest.complete();
	};

    
	DrillbitTest.runNextTest();
	


}
